""" Python Character Mapping Codec generated from 'VENDORS/MICSFT/WINDOWS/CP874.TXT' with gencodec.py.

"""#"

import codecs

### Codec APIs

class Codec(codecs.Codec):

    def encode(self,input,errors='strict'):

        return codecs.charmap_encode(input,errors,encoding_map)

    def decode(self,input,errors='strict'):

        return codecs.charmap_decode(input,errors,decoding_table)
    
class StreamWriter(Codec,codecs.StreamWriter):
    pass

class StreamReader(Codec,codecs.StreamReader):
    pass

### encodings module API

def getregentry():

    return (Codec().encode,Codec().decode,StreamReader,StreamWriter)

### Decoding Map

decoding_map = codecs.make_identity_dict(range(256))
decoding_map.update({
    0x0080: 0x20ac,	#  EURO SIGN
    0x0081: None,	#  UNDEFINED
    0x0082: None,	#  UNDEFINED
    0x0083: None,	#  UNDEFINED
    0x0084: None,	#  UNDEFINED
    0x0085: 0x2026,	#  HORIZONTAL ELLIPSIS
    0x0086: None,	#  UNDEFINED
    0x0087: None,	#  UNDEFINED
    0x0088: None,	#  UNDEFINED
    0x0089: None,	#  UNDEFINED
    0x008a: None,	#  UNDEFINED
    0x008b: None,	#  UNDEFINED
    0x008c: None,	#  UNDEFINED
    0x008d: None,	#  UNDEFINED
    0x008e: None,	#  UNDEFINED
    0x008f: None,	#  UNDEFINED
    0x0090: None,	#  UNDEFINED
    0x0091: 0x2018,	#  LEFT SINGLE QUOTATION MARK
    0x0092: 0x2019,	#  RIGHT SINGLE QUOTATION MARK
    0x0093: 0x201c,	#  LEFT DOUBLE QUOTATION MARK
    0x0094: 0x201d,	#  RIGHT DOUBLE QUOTATION MARK
    0x0095: 0x2022,	#  BULLET
    0x0096: 0x2013,	#  EN DASH
    0x0097: 0x2014,	#  EM DASH
    0x0098: None,	#  UNDEFINED
    0x0099: None,	#  UNDEFINED
    0x009a: None,	#  UNDEFINED
    0x009b: None,	#  UNDEFINED
    0x009c: None,	#  UNDEFINED
    0x009d: None,	#  UNDEFINED
    0x009e: None,	#  UNDEFINED
    0x009f: None,	#  UNDEFINED
    0x00a1: 0x0e01,	#  THAI CHARACTER KO KAI
    0x00a2: 0x0e02,	#  THAI CHARACTER KHO KHAI
    0x00a3: 0x0e03,	#  THAI CHARACTER KHO KHUAT
    0x00a4: 0x0e04,	#  THAI CHARACTER KHO KHWAI
    0x00a5: 0x0e05,	#  THAI CHARACTER KHO KHON
    0x00a6: 0x0e06,	#  THAI CHARACTER KHO RAKHANG
    0x00a7: 0x0e07,	#  THAI CHARACTER NGO NGU
    0x00a8: 0x0e08,	#  THAI CHARACTER CHO CHAN
    0x00a9: 0x0e09,	#  THAI CHARACTER CHO CHING
    0x00aa: 0x0e0a,	#  THAI CHARACTER CHO CHANG
    0x00ab: 0x0e0b,	#  THAI CHARACTER SO SO
    0x00ac: 0x0e0c,	#  THAI CHARACTER CHO CHOE
    0x00ad: 0x0e0d,	#  THAI CHARACTER YO YING
    0x00ae: 0x0e0e,	#  THAI CHARACTER DO CHADA
    0x00af: 0x0e0f,	#  THAI CHARACTER TO PATAK
    0x00b0: 0x0e10,	#  THAI CHARACTER THO THAN
    0x00b1: 0x0e11,	#  THAI CHARACTER THO NANGMONTHO
    0x00b2: 0x0e12,	#  THAI CHARACTER THO PHUTHAO
    0x00b3: 0x0e13,	#  THAI CHARACTER NO NEN
    0x00b4: 0x0e14,	#  THAI CHARACTER DO DEK
    0x00b5: 0x0e15,	#  THAI CHARACTER TO TAO
    0x00b6: 0x0e16,	#  THAI CHARACTER THO THUNG
    0x00b7: 0x0e17,	#  THAI CHARACTER THO THAHAN
    0x00b8: 0x0e18,	#  THAI CHARACTER THO THONG
    0x00b9: 0x0e19,	#  THAI CHARACTER NO NU
    0x00ba: 0x0e1a,	#  THAI CHARACTER BO BAIMAI
    0x00bb: 0x0e1b,	#  THAI CHARACTER PO PLA
    0x00bc: 0x0e1c,	#  THAI CHARACTER PHO PHUNG
    0x00bd: 0x0e1d,	#  THAI CHARACTER FO FA
    0x00be: 0x0e1e,	#  THAI CHARACTER PHO PHAN
    0x00bf: 0x0e1f,	#  THAI CHARACTER FO FAN
    0x00c0: 0x0e20,	#  THAI CHARACTER PHO SAMPHAO
    0x00c1: 0x0e21,	#  THAI CHARACTER MO MA
    0x00c2: 0x0e22,	#  THAI CHARACTER YO YAK
    0x00c3: 0x0e23,	#  THAI CHARACTER RO RUA
    0x00c4: 0x0e24,	#  THAI CHARACTER RU
    0x00c5: 0x0e25,	#  THAI CHARACTER LO LING
    0x00c6: 0x0e26,	#  THAI CHARACTER LU
    0x00c7: 0x0e27,	#  THAI CHARACTER WO WAEN
    0x00c8: 0x0e28,	#  THAI CHARACTER SO SALA
    0x00c9: 0x0e29,	#  THAI CHARACTER SO RUSI
    0x00ca: 0x0e2a,	#  THAI CHARACTER SO SUA
    0x00cb: 0x0e2b,	#  THAI CHARACTER HO HIP
    0x00cc: 0x0e2c,	#  THAI CHARACTER LO CHULA
    0x00cd: 0x0e2d,	#  THAI CHARACTER O ANG
    0x00ce: 0x0e2e,	#  THAI CHARACTER HO NOKHUK
    0x00cf: 0x0e2f,	#  THAI CHARACTER PAIYANNOI
    0x00d0: 0x0e30,	#  THAI CHARACTER SARA A
    0x00d1: 0x0e31,	#  THAI CHARACTER MAI HAN-AKAT
    0x00d2: 0x0e32,	#  THAI CHARACTER SARA AA
    0x00d3: 0x0e33,	#  THAI CHARACTER SARA AM
    0x00d4: 0x0e34,	#  THAI CHARACTER SARA I
    0x00d5: 0x0e35,	#  THAI CHARACTER SARA II
    0x00d6: 0x0e36,	#  THAI CHARACTER SARA UE
    0x00d7: 0x0e37,	#  THAI CHARACTER SARA UEE
    0x00d8: 0x0e38,	#  THAI CHARACTER SARA U
    0x00d9: 0x0e39,	#  THAI CHARACTER SARA UU
    0x00da: 0x0e3a,	#  THAI CHARACTER PHINTHU
    0x00db: None,	#  UNDEFINED
    0x00dc: None,	#  UNDEFINED
    0x00dd: None,	#  UNDEFINED
    0x00de: None,	#  UNDEFINED
    0x00df: 0x0e3f,	#  THAI CURRENCY SYMBOL BAHT
    0x00e0: 0x0e40,	#  THAI CHARACTER SARA E
    0x00e1: 0x0e41,	#  THAI CHARACTER SARA AE
    0x00e2: 0x0e42,	#  THAI CHARACTER SARA O
    0x00e3: 0x0e43,	#  THAI CHARACTER SARA AI MAIMUAN
    0x00e4: 0x0e44,	#  THAI CHARACTER SARA AI MAIMALAI
    0x00e5: 0x0e45,	#  THAI CHARACTER LAKKHANGYAO
    0x00e6: 0x0e46,	#  THAI CHARACTER MAIYAMOK
    0x00e7: 0x0e47,	#  THAI CHARACTER MAITAIKHU
    0x00e8: 0x0e48,	#  THAI CHARACTER MAI EK
    0x00e9: 0x0e49,	#  THAI CHARACTER MAI THO
    0x00ea: 0x0e4a,	#  THAI CHARACTER MAI TRI
    0x00eb: 0x0e4b,	#  THAI CHARACTER MAI CHATTAWA
    0x00ec: 0x0e4c,	#  THAI CHARACTER THANTHAKHAT
    0x00ed: 0x0e4d,	#  THAI CHARACTER NIKHAHIT
    0x00ee: 0x0e4e,	#  THAI CHARACTER YAMAKKAN
    0x00ef: 0x0e4f,	#  THAI CHARACTER FONGMAN
    0x00f0: 0x0e50,	#  THAI DIGIT ZERO
    0x00f1: 0x0e51,	#  THAI DIGIT ONE
    0x00f2: 0x0e52,	#  THAI DIGIT TWO
    0x00f3: 0x0e53,	#  THAI DIGIT THREE
    0x00f4: 0x0e54,	#  THAI DIGIT FOUR
    0x00f5: 0x0e55,	#  THAI DIGIT FIVE
    0x00f6: 0x0e56,	#  THAI DIGIT SIX
    0x00f7: 0x0e57,	#  THAI DIGIT SEVEN
    0x00f8: 0x0e58,	#  THAI DIGIT EIGHT
    0x00f9: 0x0e59,	#  THAI DIGIT NINE
    0x00fa: 0x0e5a,	#  THAI CHARACTER ANGKHANKHU
    0x00fb: 0x0e5b,	#  THAI CHARACTER KHOMUT
    0x00fc: None,	#  UNDEFINED
    0x00fd: None,	#  UNDEFINED
    0x00fe: None,	#  UNDEFINED
    0x00ff: None,	#  UNDEFINED
})

### Decoding Table

decoding_table = (
    u'\x00'	#  0x0000 -> NULL
    u'\x01'	#  0x0001 -> START OF HEADING
    u'\x02'	#  0x0002 -> START OF TEXT
    u'\x03'	#  0x0003 -> END OF TEXT
    u'\x04'	#  0x0004 -> END OF TRANSMISSION
    u'\x05'	#  0x0005 -> ENQUIRY
    u'\x06'	#  0x0006 -> ACKNOWLEDGE
    u'\x07'	#  0x0007 -> BELL
    u'\x08'	#  0x0008 -> BACKSPACE
    u'\t'	#  0x0009 -> HORIZONTAL TABULATION
    u'\n'	#  0x000a -> LINE FEED
    u'\x0b'	#  0x000b -> VERTICAL TABULATION
    u'\x0c'	#  0x000c -> FORM FEED
    u'\r'	#  0x000d -> CARRIAGE RETURN
    u'\x0e'	#  0x000e -> SHIFT OUT
    u'\x0f'	#  0x000f -> SHIFT IN
    u'\x10'	#  0x0010 -> DATA LINK ESCAPE
    u'\x11'	#  0x0011 -> DEVICE CONTROL ONE
    u'\x12'	#  0x0012 -> DEVICE CONTROL TWO
    u'\x13'	#  0x0013 -> DEVICE CONTROL THREE
    u'\x14'	#  0x0014 -> DEVICE CONTROL FOUR
    u'\x15'	#  0x0015 -> NEGATIVE ACKNOWLEDGE
    u'\x16'	#  0x0016 -> SYNCHRONOUS IDLE
    u'\x17'	#  0x0017 -> END OF TRANSMISSION BLOCK
    u'\x18'	#  0x0018 -> CANCEL
    u'\x19'	#  0x0019 -> END OF MEDIUM
    u'\x1a'	#  0x001a -> SUBSTITUTE
    u'\x1b'	#  0x001b -> ESCAPE
    u'\x1c'	#  0x001c -> FILE SEPARATOR
    u'\x1d'	#  0x001d -> GROUP SEPARATOR
    u'\x1e'	#  0x001e -> RECORD SEPARATOR
    u'\x1f'	#  0x001f -> UNIT SEPARATOR
    u' '	#  0x0020 -> SPACE
    u'!'	#  0x0021 -> EXCLAMATION MARK
    u'"'	#  0x0022 -> QUOTATION MARK
    u'#'	#  0x0023 -> NUMBER SIGN
    u'$'	#  0x0024 -> DOLLAR SIGN
    u'%'	#  0x0025 -> PERCENT SIGN
    u'&'	#  0x0026 -> AMPERSAND
    u"'"	#  0x0027 -> APOSTROPHE
    u'('	#  0x0028 -> LEFT PARENTHESIS
    u')'	#  0x0029 -> RIGHT PARENTHESIS
    u'*'	#  0x002a -> ASTERISK
    u'+'	#  0x002b -> PLUS SIGN
    u','	#  0x002c -> COMMA
    u'-'	#  0x002d -> HYPHEN-MINUS
    u'.'	#  0x002e -> FULL STOP
    u'/'	#  0x002f -> SOLIDUS
    u'0'	#  0x0030 -> DIGIT ZERO
    u'1'	#  0x0031 -> DIGIT ONE
    u'2'	#  0x0032 -> DIGIT TWO
    u'3'	#  0x0033 -> DIGIT THREE
    u'4'	#  0x0034 -> DIGIT FOUR
    u'5'	#  0x0035 -> DIGIT FIVE
    u'6'	#  0x0036 -> DIGIT SIX
    u'7'	#  0x0037 -> DIGIT SEVEN
    u'8'	#  0x0038 -> DIGIT EIGHT
    u'9'	#  0x0039 -> DIGIT NINE
    u':'	#  0x003a -> COLON
    u';'	#  0x003b -> SEMICOLON
    u'<'	#  0x003c -> LESS-THAN SIGN
    u'='	#  0x003d -> EQUALS SIGN
    u'>'	#  0x003e -> GREATER-THAN SIGN
    u'?'	#  0x003f -> QUESTION MARK
    u'@'	#  0x0040 -> COMMERCIAL AT
    u'A'	#  0x0041 -> LATIN CAPITAL LETTER A
    u'B'	#  0x0042 -> LATIN CAPITAL LETTER B
    u'C'	#  0x0043 -> LATIN CAPITAL LETTER C
    u'D'	#  0x0044 -> LATIN CAPITAL LETTER D
    u'E'	#  0x0045 -> LATIN CAPITAL LETTER E
    u'F'	#  0x0046 -> LATIN CAPITAL LETTER F
    u'G'	#  0x0047 -> LATIN CAPITAL LETTER G
    u'H'	#  0x0048 -> LATIN CAPITAL LETTER H
    u'I'	#  0x0049 -> LATIN CAPITAL LETTER I
    u'J'	#  0x004a -> LATIN CAPITAL LETTER J
    u'K'	#  0x004b -> LATIN CAPITAL LETTER K
    u'L'	#  0x004c -> LATIN CAPITAL LETTER L
    u'M'	#  0x004d -> LATIN CAPITAL LETTER M
    u'N'	#  0x004e -> LATIN CAPITAL LETTER N
    u'O'	#  0x004f -> LATIN CAPITAL LETTER O
    u'P'	#  0x0050 -> LATIN CAPITAL LETTER P
    u'Q'	#  0x0051 -> LATIN CAPITAL LETTER Q
    u'R'	#  0x0052 -> LATIN CAPITAL LETTER R
    u'S'	#  0x0053 -> LATIN CAPITAL LETTER S
    u'T'	#  0x0054 -> LATIN CAPITAL LETTER T
    u'U'	#  0x0055 -> LATIN CAPITAL LETTER U
    u'V'	#  0x0056 -> LATIN CAPITAL LETTER V
    u'W'	#  0x0057 -> LATIN CAPITAL LETTER W
    u'X'	#  0x0058 -> LATIN CAPITAL LETTER X
    u'Y'	#  0x0059 -> LATIN CAPITAL LETTER Y
    u'Z'	#  0x005a -> LATIN CAPITAL LETTER Z
    u'['	#  0x005b -> LEFT SQUARE BRACKET
    u'\\'	#  0x005c -> REVERSE SOLIDUS
    u']'	#  0x005d -> RIGHT SQUARE BRACKET
    u'^'	#  0x005e -> CIRCUMFLEX ACCENT
    u'_'	#  0x005f -> LOW LINE
    u'`'	#  0x0060 -> GRAVE ACCENT
    u'a'	#  0x0061 -> LATIN SMALL LETTER A
    u'b'	#  0x0062 -> LATIN SMALL LETTER B
    u'c'	#  0x0063 -> LATIN SMALL LETTER C
    u'd'	#  0x0064 -> LATIN SMALL LETTER D
    u'e'	#  0x0065 -> LATIN SMALL LETTER E
    u'f'	#  0x0066 -> LATIN SMALL LETTER F
    u'g'	#  0x0067 -> LATIN SMALL LETTER G
    u'h'	#  0x0068 -> LATIN SMALL LETTER H
    u'i'	#  0x0069 -> LATIN SMALL LETTER I
    u'j'	#  0x006a -> LATIN SMALL LETTER J
    u'k'	#  0x006b -> LATIN SMALL LETTER K
    u'l'	#  0x006c -> LATIN SMALL LETTER L
    u'm'	#  0x006d -> LATIN SMALL LETTER M
    u'n'	#  0x006e -> LATIN SMALL LETTER N
    u'o'	#  0x006f -> LATIN SMALL LETTER O
    u'p'	#  0x0070 -> LATIN SMALL LETTER P
    u'q'	#  0x0071 -> LATIN SMALL LETTER Q
    u'r'	#  0x0072 -> LATIN SMALL LETTER R
    u's'	#  0x0073 -> LATIN SMALL LETTER S
    u't'	#  0x0074 -> LATIN SMALL LETTER T
    u'u'	#  0x0075 -> LATIN SMALL LETTER U
    u'v'	#  0x0076 -> LATIN SMALL LETTER V
    u'w'	#  0x0077 -> LATIN SMALL LETTER W
    u'x'	#  0x0078 -> LATIN SMALL LETTER X
    u'y'	#  0x0079 -> LATIN SMALL LETTER Y
    u'z'	#  0x007a -> LATIN SMALL LETTER Z
    u'{'	#  0x007b -> LEFT CURLY BRACKET
    u'|'	#  0x007c -> VERTICAL LINE
    u'}'	#  0x007d -> RIGHT CURLY BRACKET
    u'~'	#  0x007e -> TILDE
    u'\x7f'	#  0x007f -> DELETE
    u'\u20ac'	#  0x0080 -> EURO SIGN
    u'\ufffe'	#  0x0081 -> UNDEFINED
    u'\ufffe'	#  0x0082 -> UNDEFINED
    u'\ufffe'	#  0x0083 -> UNDEFINED
    u'\ufffe'	#  0x0084 -> UNDEFINED
    u'\u2026'	#  0x0085 -> HORIZONTAL ELLIPSIS
    u'\ufffe'	#  0x0086 -> UNDEFINED
    u'\ufffe'	#  0x0087 -> UNDEFINED
    u'\ufffe'	#  0x0088 -> UNDEFINED
    u'\ufffe'	#  0x0089 -> UNDEFINED
    u'\ufffe'	#  0x008a -> UNDEFINED
    u'\ufffe'	#  0x008b -> UNDEFINED
    u'\ufffe'	#  0x008c -> UNDEFINED
    u'\ufffe'	#  0x008d -> UNDEFINED
    u'\ufffe'	#  0x008e -> UNDEFINED
    u'\ufffe'	#  0x008f -> UNDEFINED
    u'\ufffe'	#  0x0090 -> UNDEFINED
    u'\u2018'	#  0x0091 -> LEFT SINGLE QUOTATION MARK
    u'\u2019'	#  0x0092 -> RIGHT SINGLE QUOTATION MARK
    u'\u201c'	#  0x0093 -> LEFT DOUBLE QUOTATION MARK
    u'\u201d'	#  0x0094 -> RIGHT DOUBLE QUOTATION MARK
    u'\u2022'	#  0x0095 -> BULLET
    u'\u2013'	#  0x0096 -> EN DASH
    u'\u2014'	#  0x0097 -> EM DASH
    u'\ufffe'	#  0x0098 -> UNDEFINED
    u'\ufffe'	#  0x0099 -> UNDEFINED
    u'\ufffe'	#  0x009a -> UNDEFINED
    u'\ufffe'	#  0x009b -> UNDEFINED
    u'\ufffe'	#  0x009c -> UNDEFINED
    u'\ufffe'	#  0x009d -> UNDEFINED
    u'\ufffe'	#  0x009e -> UNDEFINED
    u'\ufffe'	#  0x009f -> UNDEFINED
    u'\xa0'	#  0x00a0 -> NO-BREAK SPACE
    u'\u0e01'	#  0x00a1 -> THAI CHARACTER KO KAI
    u'\u0e02'	#  0x00a2 -> THAI CHARACTER KHO KHAI
    u'\u0e03'	#  0x00a3 -> THAI CHARACTER KHO KHUAT
    u'\u0e04'	#  0x00a4 -> THAI CHARACTER KHO KHWAI
    u'\u0e05'	#  0x00a5 -> THAI CHARACTER KHO KHON
    u'\u0e06'	#  0x00a6 -> THAI CHARACTER KHO RAKHANG
    u'\u0e07'	#  0x00a7 -> THAI CHARACTER NGO NGU
    u'\u0e08'	#  0x00a8 -> THAI CHARACTER CHO CHAN
    u'\u0e09'	#  0x00a9 -> THAI CHARACTER CHO CHING
    u'\u0e0a'	#  0x00aa -> THAI CHARACTER CHO CHANG
    u'\u0e0b'	#  0x00ab -> THAI CHARACTER SO SO
    u'\u0e0c'	#  0x00ac -> THAI CHARACTER CHO CHOE
    u'\u0e0d'	#  0x00ad -> THAI CHARACTER YO YING
    u'\u0e0e'	#  0x00ae -> THAI CHARACTER DO CHADA
    u'\u0e0f'	#  0x00af -> THAI CHARACTER TO PATAK
    u'\u0e10'	#  0x00b0 -> THAI CHARACTER THO THAN
    u'\u0e11'	#  0x00b1 -> THAI CHARACTER THO NANGMONTHO
    u'\u0e12'	#  0x00b2 -> THAI CHARACTER THO PHUTHAO
    u'\u0e13'	#  0x00b3 -> THAI CHARACTER NO NEN
    u'\u0e14'	#  0x00b4 -> THAI CHARACTER DO DEK
    u'\u0e15'	#  0x00b5 -> THAI CHARACTER TO TAO
    u'\u0e16'	#  0x00b6 -> THAI CHARACTER THO THUNG
    u'\u0e17'	#  0x00b7 -> THAI CHARACTER THO THAHAN
    u'\u0e18'	#  0x00b8 -> THAI CHARACTER THO THONG
    u'\u0e19'	#  0x00b9 -> THAI CHARACTER NO NU
    u'\u0e1a'	#  0x00ba -> THAI CHARACTER BO BAIMAI
    u'\u0e1b'	#  0x00bb -> THAI CHARACTER PO PLA
    u'\u0e1c'	#  0x00bc -> THAI CHARACTER PHO PHUNG
    u'\u0e1d'	#  0x00bd -> THAI CHARACTER FO FA
    u'\u0e1e'	#  0x00be -> THAI CHARACTER PHO PHAN
    u'\u0e1f'	#  0x00bf -> THAI CHARACTER FO FAN
    u'\u0e20'	#  0x00c0 -> THAI CHARACTER PHO SAMPHAO
    u'\u0e21'	#  0x00c1 -> THAI CHARACTER MO MA
    u'\u0e22'	#  0x00c2 -> THAI CHARACTER YO YAK
    u'\u0e23'	#  0x00c3 -> THAI CHARACTER RO RUA
    u'\u0e24'	#  0x00c4 -> THAI CHARACTER RU
    u'\u0e25'	#  0x00c5 -> THAI CHARACTER LO LING
    u'\u0e26'	#  0x00c6 -> THAI CHARACTER LU
    u'\u0e27'	#  0x00c7 -> THAI CHARACTER WO WAEN
    u'\u0e28'	#  0x00c8 -> THAI CHARACTER SO SALA
    u'\u0e29'	#  0x00c9 -> THAI CHARACTER SO RUSI
    u'\u0e2a'	#  0x00ca -> THAI CHARACTER SO SUA
    u'\u0e2b'	#  0x00cb -> THAI CHARACTER HO HIP
    u'\u0e2c'	#  0x00cc -> THAI CHARACTER LO CHULA
    u'\u0e2d'	#  0x00cd -> THAI CHARACTER O ANG
    u'\u0e2e'	#  0x00ce -> THAI CHARACTER HO NOKHUK
    u'\u0e2f'	#  0x00cf -> THAI CHARACTER PAIYANNOI
    u'\u0e30'	#  0x00d0 -> THAI CHARACTER SARA A
    u'\u0e31'	#  0x00d1 -> THAI CHARACTER MAI HAN-AKAT
    u'\u0e32'	#  0x00d2 -> THAI CHARACTER SARA AA
    u'\u0e33'	#  0x00d3 -> THAI CHARACTER SARA AM
    u'\u0e34'	#  0x00d4 -> THAI CHARACTER SARA I
    u'\u0e35'	#  0x00d5 -> THAI CHARACTER SARA II
    u'\u0e36'	#  0x00d6 -> THAI CHARACTER SARA UE
    u'\u0e37'	#  0x00d7 -> THAI CHARACTER SARA UEE
    u'\u0e38'	#  0x00d8 -> THAI CHARACTER SARA U
    u'\u0e39'	#  0x00d9 -> THAI CHARACTER SARA UU
    u'\u0e3a'	#  0x00da -> THAI CHARACTER PHINTHU
    u'\ufffe'	#  0x00db -> UNDEFINED
    u'\ufffe'	#  0x00dc -> UNDEFINED
    u'\ufffe'	#  0x00dd -> UNDEFINED
    u'\ufffe'	#  0x00de -> UNDEFINED
    u'\u0e3f'	#  0x00df -> THAI CURRENCY SYMBOL BAHT
    u'\u0e40'	#  0x00e0 -> THAI CHARACTER SARA E
    u'\u0e41'	#  0x00e1 -> THAI CHARACTER SARA AE
    u'\u0e42'	#  0x00e2 -> THAI CHARACTER SARA O
    u'\u0e43'	#  0x00e3 -> THAI CHARACTER SARA AI MAIMUAN
    u'\u0e44'	#  0x00e4 -> THAI CHARACTER SARA AI MAIMALAI
    u'\u0e45'	#  0x00e5 -> THAI CHARACTER LAKKHANGYAO
    u'\u0e46'	#  0x00e6 -> THAI CHARACTER MAIYAMOK
    u'\u0e47'	#  0x00e7 -> THAI CHARACTER MAITAIKHU
    u'\u0e48'	#  0x00e8 -> THAI CHARACTER MAI EK
    u'\u0e49'	#  0x00e9 -> THAI CHARACTER MAI THO
    u'\u0e4a'	#  0x00ea -> THAI CHARACTER MAI TRI
    u'\u0e4b'	#  0x00eb -> THAI CHARACTER MAI CHATTAWA
    u'\u0e4c'	#  0x00ec -> THAI CHARACTER THANTHAKHAT
    u'\u0e4d'	#  0x00ed -> THAI CHARACTER NIKHAHIT
    u'\u0e4e'	#  0x00ee -> THAI CHARACTER YAMAKKAN
    u'\u0e4f'	#  0x00ef -> THAI CHARACTER FONGMAN
    u'\u0e50'	#  0x00f0 -> THAI DIGIT ZERO
    u'\u0e51'	#  0x00f1 -> THAI DIGIT ONE
    u'\u0e52'	#  0x00f2 -> THAI DIGIT TWO
    u'\u0e53'	#  0x00f3 -> THAI DIGIT THREE
    u'\u0e54'	#  0x00f4 -> THAI DIGIT FOUR
    u'\u0e55'	#  0x00f5 -> THAI DIGIT FIVE
    u'\u0e56'	#  0x00f6 -> THAI DIGIT SIX
    u'\u0e57'	#  0x00f7 -> THAI DIGIT SEVEN
    u'\u0e58'	#  0x00f8 -> THAI DIGIT EIGHT
    u'\u0e59'	#  0x00f9 -> THAI DIGIT NINE
    u'\u0e5a'	#  0x00fa -> THAI CHARACTER ANGKHANKHU
    u'\u0e5b'	#  0x00fb -> THAI CHARACTER KHOMUT
    u'\ufffe'	#  0x00fc -> UNDEFINED
    u'\ufffe'	#  0x00fd -> UNDEFINED
    u'\ufffe'	#  0x00fe -> UNDEFINED
    u'\ufffe'	#  0x00ff -> UNDEFINED
)

### Encoding Map

encoding_map = {
    0x0000: 0x0000,	#  NULL
    0x0001: 0x0001,	#  START OF HEADING
    0x0002: 0x0002,	#  START OF TEXT
    0x0003: 0x0003,	#  END OF TEXT
    0x0004: 0x0004,	#  END OF TRANSMISSION
    0x0005: 0x0005,	#  ENQUIRY
    0x0006: 0x0006,	#  ACKNOWLEDGE
    0x0007: 0x0007,	#  BELL
    0x0008: 0x0008,	#  BACKSPACE
    0x0009: 0x0009,	#  HORIZONTAL TABULATION
    0x000a: 0x000a,	#  LINE FEED
    0x000b: 0x000b,	#  VERTICAL TABULATION
    0x000c: 0x000c,	#  FORM FEED
    0x000d: 0x000d,	#  CARRIAGE RETURN
    0x000e: 0x000e,	#  SHIFT OUT
    0x000f: 0x000f,	#  SHIFT IN
    0x0010: 0x0010,	#  DATA LINK ESCAPE
    0x0011: 0x0011,	#  DEVICE CONTROL ONE
    0x0012: 0x0012,	#  DEVICE CONTROL TWO
    0x0013: 0x0013,	#  DEVICE CONTROL THREE
    0x0014: 0x0014,	#  DEVICE CONTROL FOUR
    0x0015: 0x0015,	#  NEGATIVE ACKNOWLEDGE
    0x0016: 0x0016,	#  SYNCHRONOUS IDLE
    0x0017: 0x0017,	#  END OF TRANSMISSION BLOCK
    0x0018: 0x0018,	#  CANCEL
    0x0019: 0x0019,	#  END OF MEDIUM
    0x001a: 0x001a,	#  SUBSTITUTE
    0x001b: 0x001b,	#  ESCAPE
    0x001c: 0x001c,	#  FILE SEPARATOR
    0x001d: 0x001d,	#  GROUP SEPARATOR
    0x001e: 0x001e,	#  RECORD SEPARATOR
    0x001f: 0x001f,	#  UNIT SEPARATOR
    0x0020: 0x0020,	#  SPACE
    0x0021: 0x0021,	#  EXCLAMATION MARK
    0x0022: 0x0022,	#  QUOTATION MARK
    0x0023: 0x0023,	#  NUMBER SIGN
    0x0024: 0x0024,	#  DOLLAR SIGN
    0x0025: 0x0025,	#  PERCENT SIGN
    0x0026: 0x0026,	#  AMPERSAND
    0x0027: 0x0027,	#  APOSTROPHE
    0x0028: 0x0028,	#  LEFT PARENTHESIS
    0x0029: 0x0029,	#  RIGHT PARENTHESIS
    0x002a: 0x002a,	#  ASTERISK
    0x002b: 0x002b,	#  PLUS SIGN
    0x002c: 0x002c,	#  COMMA
    0x002d: 0x002d,	#  HYPHEN-MINUS
    0x002e: 0x002e,	#  FULL STOP
    0x002f: 0x002f,	#  SOLIDUS
    0x0030: 0x0030,	#  DIGIT ZERO
    0x0031: 0x0031,	#  DIGIT ONE
    0x0032: 0x0032,	#  DIGIT TWO
    0x0033: 0x0033,	#  DIGIT THREE
    0x0034: 0x0034,	#  DIGIT FOUR
    0x0035: 0x0035,	#  DIGIT FIVE
    0x0036: 0x0036,	#  DIGIT SIX
    0x0037: 0x0037,	#  DIGIT SEVEN
    0x0038: 0x0038,	#  DIGIT EIGHT
    0x0039: 0x0039,	#  DIGIT NINE
    0x003a: 0x003a,	#  COLON
    0x003b: 0x003b,	#  SEMICOLON
    0x003c: 0x003c,	#  LESS-THAN SIGN
    0x003d: 0x003d,	#  EQUALS SIGN
    0x003e: 0x003e,	#  GREATER-THAN SIGN
    0x003f: 0x003f,	#  QUESTION MARK
    0x0040: 0x0040,	#  COMMERCIAL AT
    0x0041: 0x0041,	#  LATIN CAPITAL LETTER A
    0x0042: 0x0042,	#  LATIN CAPITAL LETTER B
    0x0043: 0x0043,	#  LATIN CAPITAL LETTER C
    0x0044: 0x0044,	#  LATIN CAPITAL LETTER D
    0x0045: 0x0045,	#  LATIN CAPITAL LETTER E
    0x0046: 0x0046,	#  LATIN CAPITAL LETTER F
    0x0047: 0x0047,	#  LATIN CAPITAL LETTER G
    0x0048: 0x0048,	#  LATIN CAPITAL LETTER H
    0x0049: 0x0049,	#  LATIN CAPITAL LETTER I
    0x004a: 0x004a,	#  LATIN CAPITAL LETTER J
    0x004b: 0x004b,	#  LATIN CAPITAL LETTER K
    0x004c: 0x004c,	#  LATIN CAPITAL LETTER L
    0x004d: 0x004d,	#  LATIN CAPITAL LETTER M
    0x004e: 0x004e,	#  LATIN CAPITAL LETTER N
    0x004f: 0x004f,	#  LATIN CAPITAL LETTER O
    0x0050: 0x0050,	#  LATIN CAPITAL LETTER P
    0x0051: 0x0051,	#  LATIN CAPITAL LETTER Q
    0x0052: 0x0052,	#  LATIN CAPITAL LETTER R
    0x0053: 0x0053,	#  LATIN CAPITAL LETTER S
    0x0054: 0x0054,	#  LATIN CAPITAL LETTER T
    0x0055: 0x0055,	#  LATIN CAPITAL LETTER U
    0x0056: 0x0056,	#  LATIN CAPITAL LETTER V
    0x0057: 0x0057,	#  LATIN CAPITAL LETTER W
    0x0058: 0x0058,	#  LATIN CAPITAL LETTER X
    0x0059: 0x0059,	#  LATIN CAPITAL LETTER Y
    0x005a: 0x005a,	#  LATIN CAPITAL LETTER Z
    0x005b: 0x005b,	#  LEFT SQUARE BRACKET
    0x005c: 0x005c,	#  REVERSE SOLIDUS
    0x005d: 0x005d,	#  RIGHT SQUARE BRACKET
    0x005e: 0x005e,	#  CIRCUMFLEX ACCENT
    0x005f: 0x005f,	#  LOW LINE
    0x0060: 0x0060,	#  GRAVE ACCENT
    0x0061: 0x0061,	#  LATIN SMALL LETTER A
    0x0062: 0x0062,	#  LATIN SMALL LETTER B
    0x0063: 0x0063,	#  LATIN SMALL LETTER C
    0x0064: 0x0064,	#  LATIN SMALL LETTER D
    0x0065: 0x0065,	#  LATIN SMALL LETTER E
    0x0066: 0x0066,	#  LATIN SMALL LETTER F
    0x0067: 0x0067,	#  LATIN SMALL LETTER G
    0x0068: 0x0068,	#  LATIN SMALL LETTER H
    0x0069: 0x0069,	#  LATIN SMALL LETTER I
    0x006a: 0x006a,	#  LATIN SMALL LETTER J
    0x006b: 0x006b,	#  LATIN SMALL LETTER K
    0x006c: 0x006c,	#  LATIN SMALL LETTER L
    0x006d: 0x006d,	#  LATIN SMALL LETTER M
    0x006e: 0x006e,	#  LATIN SMALL LETTER N
    0x006f: 0x006f,	#  LATIN SMALL LETTER O
    0x0070: 0x0070,	#  LATIN SMALL LETTER P
    0x0071: 0x0071,	#  LATIN SMALL LETTER Q
    0x0072: 0x0072,	#  LATIN SMALL LETTER R
    0x0073: 0x0073,	#  LATIN SMALL LETTER S
    0x0074: 0x0074,	#  LATIN SMALL LETTER T
    0x0075: 0x0075,	#  LATIN SMALL LETTER U
    0x0076: 0x0076,	#  LATIN SMALL LETTER V
    0x0077: 0x0077,	#  LATIN SMALL LETTER W
    0x0078: 0x0078,	#  LATIN SMALL LETTER X
    0x0079: 0x0079,	#  LATIN SMALL LETTER Y
    0x007a: 0x007a,	#  LATIN SMALL LETTER Z
    0x007b: 0x007b,	#  LEFT CURLY BRACKET
    0x007c: 0x007c,	#  VERTICAL LINE
    0x007d: 0x007d,	#  RIGHT CURLY BRACKET
    0x007e: 0x007e,	#  TILDE
    0x007f: 0x007f,	#  DELETE
    0x00a0: 0x00a0,	#  NO-BREAK SPACE
    0x0e01: 0x00a1,	#  THAI CHARACTER KO KAI
    0x0e02: 0x00a2,	#  THAI CHARACTER KHO KHAI
    0x0e03: 0x00a3,	#  THAI CHARACTER KHO KHUAT
    0x0e04: 0x00a4,	#  THAI CHARACTER KHO KHWAI
    0x0e05: 0x00a5,	#  THAI CHARACTER KHO KHON
    0x0e06: 0x00a6,	#  THAI CHARACTER KHO RAKHANG
    0x0e07: 0x00a7,	#  THAI CHARACTER NGO NGU
    0x0e08: 0x00a8,	#  THAI CHARACTER CHO CHAN
    0x0e09: 0x00a9,	#  THAI CHARACTER CHO CHING
    0x0e0a: 0x00aa,	#  THAI CHARACTER CHO CHANG
    0x0e0b: 0x00ab,	#  THAI CHARACTER SO SO
    0x0e0c: 0x00ac,	#  THAI CHARACTER CHO CHOE
    0x0e0d: 0x00ad,	#  THAI CHARACTER YO YING
    0x0e0e: 0x00ae,	#  THAI CHARACTER DO CHADA
    0x0e0f: 0x00af,	#  THAI CHARACTER TO PATAK
    0x0e10: 0x00b0,	#  THAI CHARACTER THO THAN
    0x0e11: 0x00b1,	#  THAI CHARACTER THO NANGMONTHO
    0x0e12: 0x00b2,	#  THAI CHARACTER THO PHUTHAO
    0x0e13: 0x00b3,	#  THAI CHARACTER NO NEN
    0x0e14: 0x00b4,	#  THAI CHARACTER DO DEK
    0x0e15: 0x00b5,	#  THAI CHARACTER TO TAO
    0x0e16: 0x00b6,	#  THAI CHARACTER THO THUNG
    0x0e17: 0x00b7,	#  THAI CHARACTER THO THAHAN
    0x0e18: 0x00b8,	#  THAI CHARACTER THO THONG
    0x0e19: 0x00b9,	#  THAI CHARACTER NO NU
    0x0e1a: 0x00ba,	#  THAI CHARACTER BO BAIMAI
    0x0e1b: 0x00bb,	#  THAI CHARACTER PO PLA
    0x0e1c: 0x00bc,	#  THAI CHARACTER PHO PHUNG
    0x0e1d: 0x00bd,	#  THAI CHARACTER FO FA
    0x0e1e: 0x00be,	#  THAI CHARACTER PHO PHAN
    0x0e1f: 0x00bf,	#  THAI CHARACTER FO FAN
    0x0e20: 0x00c0,	#  THAI CHARACTER PHO SAMPHAO
    0x0e21: 0x00c1,	#  THAI CHARACTER MO MA
    0x0e22: 0x00c2,	#  THAI CHARACTER YO YAK
    0x0e23: 0x00c3,	#  THAI CHARACTER RO RUA
    0x0e24: 0x00c4,	#  THAI CHARACTER RU
    0x0e25: 0x00c5,	#  THAI CHARACTER LO LING
    0x0e26: 0x00c6,	#  THAI CHARACTER LU
    0x0e27: 0x00c7,	#  THAI CHARACTER WO WAEN
    0x0e28: 0x00c8,	#  THAI CHARACTER SO SALA
    0x0e29: 0x00c9,	#  THAI CHARACTER SO RUSI
    0x0e2a: 0x00ca,	#  THAI CHARACTER SO SUA
    0x0e2b: 0x00cb,	#  THAI CHARACTER HO HIP
    0x0e2c: 0x00cc,	#  THAI CHARACTER LO CHULA
    0x0e2d: 0x00cd,	#  THAI CHARACTER O ANG
    0x0e2e: 0x00ce,	#  THAI CHARACTER HO NOKHUK
    0x0e2f: 0x00cf,	#  THAI CHARACTER PAIYANNOI
    0x0e30: 0x00d0,	#  THAI CHARACTER SARA A
    0x0e31: 0x00d1,	#  THAI CHARACTER MAI HAN-AKAT
    0x0e32: 0x00d2,	#  THAI CHARACTER SARA AA
    0x0e33: 0x00d3,	#  THAI CHARACTER SARA AM
    0x0e34: 0x00d4,	#  THAI CHARACTER SARA I
    0x0e35: 0x00d5,	#  THAI CHARACTER SARA II
    0x0e36: 0x00d6,	#  THAI CHARACTER SARA UE
    0x0e37: 0x00d7,	#  THAI CHARACTER SARA UEE
    0x0e38: 0x00d8,	#  THAI CHARACTER SARA U
    0x0e39: 0x00d9,	#  THAI CHARACTER SARA UU
    0x0e3a: 0x00da,	#  THAI CHARACTER PHINTHU
    0x0e3f: 0x00df,	#  THAI CURRENCY SYMBOL BAHT
    0x0e40: 0x00e0,	#  THAI CHARACTER SARA E
    0x0e41: 0x00e1,	#  THAI CHARACTER SARA AE
    0x0e42: 0x00e2,	#  THAI CHARACTER SARA O
    0x0e43: 0x00e3,	#  THAI CHARACTER SARA AI MAIMUAN
    0x0e44: 0x00e4,	#  THAI CHARACTER SARA AI MAIMALAI
    0x0e45: 0x00e5,	#  THAI CHARACTER LAKKHANGYAO
    0x0e46: 0x00e6,	#  THAI CHARACTER MAIYAMOK
    0x0e47: 0x00e7,	#  THAI CHARACTER MAITAIKHU
    0x0e48: 0x00e8,	#  THAI CHARACTER MAI EK
    0x0e49: 0x00e9,	#  THAI CHARACTER MAI THO
    0x0e4a: 0x00ea,	#  THAI CHARACTER MAI TRI
    0x0e4b: 0x00eb,	#  THAI CHARACTER MAI CHATTAWA
    0x0e4c: 0x00ec,	#  THAI CHARACTER THANTHAKHAT
    0x0e4d: 0x00ed,	#  THAI CHARACTER NIKHAHIT
    0x0e4e: 0x00ee,	#  THAI CHARACTER YAMAKKAN
    0x0e4f: 0x00ef,	#  THAI CHARACTER FONGMAN
    0x0e50: 0x00f0,	#  THAI DIGIT ZERO
    0x0e51: 0x00f1,	#  THAI DIGIT ONE
    0x0e52: 0x00f2,	#  THAI DIGIT TWO
    0x0e53: 0x00f3,	#  THAI DIGIT THREE
    0x0e54: 0x00f4,	#  THAI DIGIT FOUR
    0x0e55: 0x00f5,	#  THAI DIGIT FIVE
    0x0e56: 0x00f6,	#  THAI DIGIT SIX
    0x0e57: 0x00f7,	#  THAI DIGIT SEVEN
    0x0e58: 0x00f8,	#  THAI DIGIT EIGHT
    0x0e59: 0x00f9,	#  THAI DIGIT NINE
    0x0e5a: 0x00fa,	#  THAI CHARACTER ANGKHANKHU
    0x0e5b: 0x00fb,	#  THAI CHARACTER KHOMUT
    0x2013: 0x0096,	#  EN DASH
    0x2014: 0x0097,	#  EM DASH
    0x2018: 0x0091,	#  LEFT SINGLE QUOTATION MARK
    0x2019: 0x0092,	#  RIGHT SINGLE QUOTATION MARK
    0x201c: 0x0093,	#  LEFT DOUBLE QUOTATION MARK
    0x201d: 0x0094,	#  RIGHT DOUBLE QUOTATION MARK
    0x2022: 0x0095,	#  BULLET
    0x2026: 0x0085,	#  HORIZONTAL ELLIPSIS
    0x20ac: 0x0080,	#  EURO SIGN
}